/* scry_client.h      Distribution 1.2   91/1/28   Scry */

/*   The Scry system is copyright (C) 1988-1991 Regents  of  the
University  of  California.   Anyone may reproduce ``Scry'',
the software in this distribution, in whole or in part, pro-
vided that:

(1)  Any copy  or  redistribution  of  Scry  must  show  the
     Regents  of  the  University of California, through its
     Lawrence Berkeley Laboratory, as the source,  and  must
     include this notice;

(2)  Any use of this software must reference this  distribu-
     tion,  state that the software copyright is held by the
     Regents of the University of California, and  that  the
     software is used by their permission.

     It is acknowledged that the U.S. Government has  rights
in  Scry  under  Contract DE-AC03-765F00098 between the U.S.
Department of Energy and the University of California.

     Scry is provided as a professional  academic  contribu-
tion  for  joint exchange.  Thus it is experimental, is pro-
vided ``as is'', with no warranties of any kind  whatsoever,
no  support,  promise  of updates, or printed documentation.
The Regents of the University of California  shall  have  no
liability  with respect to the infringement of copyrights by
Scry, or any part thereof. */


#include <netdb.h>
#include <rpc/rpc.h>
#include <sys/socket.h>
#include <sys/time.h>

#include "scry.h"

/* remote procedure numbers */

#define S_INITPROC 2	/* initialize VTR or videodisk */
#define S_CLEARPROC 3	/* clear server display */
#define S_CLOSEPROC 4	/* relinquish control */
#define S_FILENAMEPROC 5	/* communicate Anima file name */
#define S_DISPLAYPROC 8	/* decompress and display */
#define S_VISPROC 11	/* get server display info */

    /* client handle */
extern CLIENT *S_client ;

    /* give up after certain amount of time */
extern struct timeval S_total_timeout ;

    /* number of bytes in original image before compression and/or
       truncation has been performed */
extern int S_orig_image_total ;

extern int S_during_rpc ;
extern int S_make_closing_call ;
